
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>.NET Remoting程序开发入门篇 / iVAN</title>

    <meta name="description" content=".NET Remoting程序开发入门篇 程序 一.Remoting基础 什么是Remoting,简而言之,我们可以将其看作是一种分布式处理方式.从微软的产品角度来看,可以说Remoting就是DCOM的一种升级,它改善了很多功能,并极好的融合到.Net平台下.Microsoft? .NET Remoting 提供了一种允许对象通过应用程序域与另一对象进行交互的框架.这也正是我们使用Remoting的原因.为什么呢?在Windows操作系统中,是将应用程序分离为单独的进程.这个进程形成了应用程序代码和数据周围的一道边界.如果不采用进程间">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">.NET Remoting程序开发入门篇</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>程序</p>
<p>　　<b>一、Remoting基础</b></p>
<p>　　什么是Remoting，简而言之，我们可以将其看作是一种分布式处理方式。从微软的产品角度来看，可以说Remoting就是DCOM的一种升级，它改善了很多功能，并极好的融合到.Net平台下。Microsoft? .NET Remoting 提供了一种允许对象通过应用程序域与另一对象进行交互的框架。这也正是我们使用Remoting的原因。为什么呢？在Windows操作系统中，是将应用程序分离为单独的进程。这个进程形成了应用程序代码和数据周围的一道边界。如果不采用进程间通信（RPC）机制，则在一个进程中执行的代码就不能访问另一进程。这是一种操作系统对应用程序的保护机制。然而在某些情况下，我们需要跨过应用程序域，与另外的应用程序域进行通信，即穿越边界。 在Remoting中是通过通道（channel）来实现两个应用程序域之间对象的通信的。如图所示：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMjAwNzc3MTg1MDQ4ODMwLmpwZw==.jpg">开发</a>入门篇-.net remoting"&gt;</p>
<p>　　首先，客户端通过Remoting，访问通道以获得服务端对象，再通过代理解析为客户端对象。这就提供一种可能性，即以服务的方式来发布服务器对象。远程对象代码可以运行在服务器上（如服务器激活的对象和客户端激活的对象），然后客户端再通过Remoting连接服务器，获得该服务对象并通过序列化在客户端运行。</p>
<p>　　在Remoting中，对于要传递的对象，设计者除了需要了解通道的类型和端口号之外，无需再了解数据包的格式。但必须注意的是，客户端在获取服务器端对象时，并不是获得实际的服务端对象，而是获得它的引用。这既保证了客户端和服务器端有关对象的松散耦合，同时也优化了通信的性能。</p>
<p>　　1、Remoting的两种通道</p>
<p>　　Remoting的通道主要有两种：Tcp和Http。在.Net中，System.Runtime.Remoting.Channel中定义了IChannel接口。IChannel接口包括了TcpChannel通道类型和Http通道类型。它们分别对应Remoting通道的这两种类型。</p>
<p>　　TcpChannel类型放在名字空间System.Runtime.Remoting.Channel.Tcp中。Tcp通道提供了基于Socket的传输工具，使用Tcp协议来跨越Remoting边界传输序列化的消息流。TcpChannel类型默认使用二进制格式序列化消息对象，因此它具有更高的传输性能。HttpChannel类型放在名字空间System.Runtime.Remoting.Channel.Http中。它提供了一种使用Http协议，使其能在Internet上穿越防火墙传输序列化消息流。默认情况下，HttpChannel类型使用Soap格式序列化消息对象，因此它具有更好的互操作性。通常在局域网内，我们更多地使用TcpChannel；如果要穿越防火墙，则使用HttpChannel。</p>
<p>　　2、远程对象的激活方式</p>
<p>　　在访问远程类型的一个对象实例之前，必须通过一个名为Activation的进程创建它并进行初始化。这种客户端通过通道来创建远程对象，称为对象的激活。在Remoting中，远程对象的激活分为两大类：服务器端激活和客户端激活。</p>
<p>　　(1) 服务器端激活，又叫做WellKnow方式，很多又翻译为知名对象。为什么称为知名对象激活模式呢？是因为服务器应用程序在激活对象实例之前会在一个众所周知的统一资源标识符(URI)上来发布这个类型。然后该服务器进程会为此类型配置一个WellKnown对象，并根据指定的端口或地址来发布对象。.Net Remoting把服务器端激活又分为SingleTon模式和SingleCall模式两种。</p>
<p>　　SingleTon模式：此为有状态模式。如果设置为SingleTon激活方式，则Remoting将为所有客户端建立同一个对象实例。当对象处于活动状态时，SingleTon实例会处理所有后来的客户端访问请求，而不管它们是同一个客户端，还是其他客户端。SingleTon实例将在方法调用中一直维持其状态。举例来说，如果一个远程对象有一个累加方法（i=0；++i），被多个客户端（例如两个）调用。如果设置为SingleTon方式，则第一个客户获得值为1，第二个客户获得值为2，因为他们获得的对象实例是相同的。如果熟悉Asp.Net的状态管理，我们可以认为它是一种Application状态。</p>
<p>　　SingleCall模式：SingleCall是一种无状态模式。一旦设置为SingleCall模式，则当客户端调用远程对象的方法时，Remoting会为每一个客户端建立一个远程对象实例，至于对象实例的销毁则是由GC自动管理的。同上一个例子而言，则访问远程对象的两个客户获得的都是1。我们仍然可以借鉴Asp.Net的状态管理，认为它是一种Session状态。</p>
<p>　　(2) 客户端激活。与WellKnown模式不同，Remoting在激活每个对象实例的时候，会给每个客户端激活的类型指派一个URI。客户端激活模式一旦获得客户端的请求，将为每一个客户端都建立一个实例引用。SingleCall模式和客户端激活模式是有区别的：首先，对象实例创建的时间不一样。客户端激活方式是客户一旦发出调用的请求，就实例化；而SingleCall则是要等到调用对象方法时再创建。其次，SingleCall模式激活的对象是无状态的，对象生命期的管理是由GC管理的，而客户端激活的对象则有状态，其生命周期可自定义。其三，两种激活模式在服务器端和客户端实现的方法不一样。尤其是在客户端，SingleCall模式是由GetObject()来激活，它调用对象默认的构造函数。而客户端激活模式，则通过CreateInstance()来激活，它可以传递参数，所以可以调用自定义的构造函数来创建实例。</p>
<p>　　<b>二、远程对象的定义</b></p>
<p>　　前面讲到，客户端在获取服务器端对象时，并不是获得实际的服务端对象，而是获得它的引用。因此在Remoting中，对于远程对象有一些必须的定义规范要遵循。</p>
<p>　　由于Remoting传递的对象是以引用的方式，因此所传递的远程对象类必须继承MarshalByRefObject。MSDN对MarshalByRefObject的说明是：MarshalByRefObject 是那些通过使用代理交换消息来跨越应用程序域边界进行通信的对象的基类。不是从 MarshalByRefObject 继承的对象会以隐式方式按值封送。当远程应用程序引用一个按值封送的对象时，将跨越远程处理边界传递该对象的副本。因为您希望使用代理方法而不是副本方法进行通信，因此需要继承MarshallByRefObject。</p>
<p>　　以下是一个远程对象类的定义：</p>
<p>public class ServerObject:MarshalByRefObject<br />{<br />　public Person GetPersonInfo(string name,string sex,int age)<br />　{<br />　　Person person = new Person();<br />　　person.Name = name;<br />　　person.Sex = sex;<br />　　person.Age = age;<br />　　return person;<br />　}<br />}<br />　　这个类只实现了最简单的方法，就是设置一个人的基本信息，并返回一个Person类对象。注意这里返回的Person类。由于这里所传递的Person则是以传值的方式来完成的，而Remoting要求必须是引用的对象，所以必须将Person类序列化。</p>
<p>　　因此，在Remoting中的远程对象中，如果还要调用或传递某个对象，例如类，或者结构，则该类或结构则必须实现串行化Attribute[SerializableAttribute]：</p>
<p>[Serializable]<br />public class Person<br />{<br />　public Person()<br />　{}</p>
<p>　private string name;<br />　private string sex;<br />　private int age;</p>
<p>　public string Name<br />　{<br />　　get {return name;}<br />　　set {name = value;}<br />　}</p>
<p>　public string Sex<br />　{<br />　　get {return sex;}<br />　　set {sex = value;}<br />　}</p>
<p>　public int Age<br />　{<br />　　get {return age;}<br />　　set {age = value;}<br />　}<br />}<br />　　将该远程对象以类库的方式编译成Dll。这个Dll将分别放在服务器端和客户端，以添加引用。</p>
<p>　　在Remoting中能够传递的远程对象可以是各种类型，包括复杂的DataSet对象，只要它能够被序列化。远程对象也可以包含事件，但服务器端对于事件的处理比较特殊，我将在本系列之三中介绍。</p>
<p>　　<strong>三、服务器端<br /></strong><br />　　根据第一部分所述，根据激活模式的不同，通道类型的不同服务器端的实现方式也有所不同。大体上说，服务器端应分为三步：</p>
<p>　　1、注册通道</p>
<p>　　要跨越应用程序域进行通信，必须实现通道。如前所述，Remoting提供了IChannel接口，分别包含TcpChannel和HttpChannel两种类型的通道。这两种类型除了性能和序列化数据的格式不同外，实现的方式完全一致，因此下面我们就以TcpChannel为例。</p>
<p>　　注册TcpChannel，首先要在项目中添加引用“System.Runtime.Remoting”，然后using名字空间：System.Runtime.Remoting.Channel.Tcp。代码如下：</p>
<p>TcpChannel channel = new TcpChannel(8080);<br />ChannelServices.RegisterChannel(channel);<br />　　在实例化通道对象时，将端口号作为参数传递。然后再调用静态方法RegisterChannel()来注册该通道对象即可。</p>
<p>　　2、注册远程对象</p>
<p>　　注册了通道后，要能激活远程对象，必须在通道中注册该对象。根据激活模式的不同，注册对象的方法也不同。</p>
<p>　　(1) SingleTon模式</p>
<p>　　对于WellKnown对象，可以通过静态方法RemotingConfiguration.RegisterWellKnownServiceType()来实现：</p>
<p>RemotingConfiguration.RegisterWellKnownServiceType(typeof(ServerRemoteObject.ServerObject),<br />"ServiceMessage",WellKnownObjectMode.SingleTon);<br />　　(2)SingleCall模式</p>
<p>　　注册对象的方法基本上和SingleTon模式相同，只需要将枚举参数WellKnownObjectMode改为SingleCall就可以了。</p>
<p>RemotingConfiguration.RegisterWellKnownServiceType(typeof(ServerRemoteObject.ServerObject),<br />"ServiceMessage",WellKnownObjectMode.SingleCall);<br />　　(3)客户端激活模式</p>
<p>　　对于客户端激活模式，使用的方法又有不同，但区别不大，看了代码就一目了然。</p>
<p>RemotingConfiguration.ApplicationName = "ServiceMessage";<br />RemotingConfiguration.RegisterActivatedServiceType(typeof(ServerRemoteObject.ServerObject));<br />　　为什么要在注册对象方法前设置ApplicationName属性呢？其实这个属性就是该对象的URI。对于WellKnown模式，URI是放在RegisterWellKnownServiceType()方法的参数中，当然也可以拿出来专门对ApplicationName属性赋值。而RegisterActivatedServiceType()方法的重载中，没有ApplicationName的参数，所以必须分开。</p>
<p>　　3、注销通道</p>
<p>　　如果要关闭Remoting的服务，则需要注销通道，也可以关闭对通道的监听。在Remoting中当我们注册通道的时候，就自动开启了通道的监听。而如果关闭了对通道的监听，则该通道就无法接受客户端的请求，但通道仍然存在，如果你想再一次注册该通道，会抛出异常。</p>
<p>//获得当前已注册的通道；<br />IChannel[] channels = ChannelServices.RegisteredChannels;</p>
<p>//关闭指定名为MyTcp的通道；<br />foreach (IChannel eachChannel in channels)<br />{<br />　if (eachChannel.ChannelName == "MyTcp")<br />　{<br />　　TcpChannel tcpChannel = (TcpChannel)eachChannel;</p>
<p>　　//关闭监听；<br />　　tcpChannel.StopListening(null);</p>
<p>　　//注销通道；<br />　　ChannelServices.UnregisterChannel(tcpChannel);<br />　}<br />}<br />　　代码中，RegisterdChannel属性获得的是当前已注册的通道。在Remoting中，是允许同时注册多个通道的，这一点会在后面说明。</p>
<p>　　<b>四、客户端</b></p>
<p>　　客户端主要做两件事，一是注册通道。这一点从图一就可以看出，Remoting中服务器端和客户端都必须通过通道来传递消息，以获得远程对象。第二步则是获得该远程对象。</p>
<p>　　1、注册通道：</p>
<p>TcpChannel channel = new TcpChannel();<br />ChannelServices.RegisterChannel(channel);</p>
<p>　　注意在客户端实例化通道时，是调用的默认构造函数，即没有传递端口号。事实上，这个端口号是缺一不可的，只不过它的指定被放在后面作为了Uri的一部分。</p>
<p>　　2、获得远程对象。</p>
<p>　　与服务器端相同，不同的激活模式决定了客户端的实现方式也将不同。不过这个区别仅仅是WellKnown激活模式和客户端激活模式之间的区别，而对于SingleTon和SingleCall模式，客户端的实现完全相同。</p>
<p>　　 (1) WellKnown激活模式</p>
<p>　　要获得服务器端的知名远程对象，可通过Activator进程的GetObject()方法来获得：</p>
<p>ServerRemoteObject.ServerObject serverObj = (ServerRemoteObject.ServerObject)Activator.GetObject(<br />typeof(ServerRemoteObject.ServerObject), "tcp://localhost:8080/ServiceMessage");<br />　　首先以WellKnown模式激活，客户端获得对象的方法是使用GetObject（）。其中参数第一个是远程对象的类型。第二个参数就是服务器端的uri。如果是http通道，自然是用http://localhost:8080/ServiceMessage了。因为我是用本地机，所以这里是localhost，你可以用具体的服务器IP地址来代替它。端口必须和服务器端的端口一致。后面则是服务器定义的远程对象服务名，即ApplicationName属性的内容。</p>
<p>　　(2) 客户端激活模式</p>
<p>　　如前所述，WellKnown模式在客户端创建对象时，只能调用默认的构造函数，上面的代码就说明了这一点，因为GetObject()方法不能传递构造函数的参数。而客户端激活模式则可以通过自定义的构造函数来创建远程对象。</p>
<p>　　客户端激活模式有两种方法：</p>
<p>　　1) 调用RemotingConfiguration的静态方法RegisterActivatedClientType()。这个方法返回值为Void，它只是将远程对象注册在客户端而已。具体的实例化还需要调用对象类的构造函数。</p>
<p>RemotingConfiguration.RegisterActivatedClientType( typeof(ServerRemoteObject.ServerObject),<br />"tcp://localhost:8080/ServiceMessage");<br />ServerRemoteObject.ServerObject serverObj = new ServerRemoteObject.ServerObject();<br />　　2) 调用进程Activator的CreateInstance()方法。这个方法将创建方法参数指定类型的类对象。它与前面的GetObject()不同的是，它要在客户端调用构造函数，而GetObject()只是获得对象，而创建实例是在服务器端完成的。CreateInstance()方法有很多个重载，我着重说一下其中常用的两个。</p>
<p>　　 a、 public static object CreateInstance(Type type, object[] args, object[] activationAttributes);</p>
<p>　　参数说明：</p>
<p>　　type：要创建的对象的类型。<br />　　args ：与要调用构造函数的参数数量、顺序和类型匹配的参数数组。如果 args 为空数组或空引用（Visual Basic 中为 Nothing），则调用不带任何参数的构造函数（默认构造函数）。<br />　　activationAttributes ：包含一个或多个可以参与激活的属性的数组。</p>
<p>　　这里的参数args是一个object[]数组类型。它可以传递要创建对象的构造函数中的参数。从这里其实可以得到一个结论：WellKnown激活模式所传递的远程对象类，只能使用默认的构造函数；而Activated模式则可以用户自定义构造函数。activationAttributes参数在这个方法中通常用来传递服务器的url。</p>
<p>　　假设我们的远程对象类ServerObject有个构造函数：</p>
<p>ServerObject(string pName,string pSex,int pAge)<br />{<br />　name = pName;<br />　sex = pSex;<br />　age = pAge;<br />}<br />　　那么实现的代码是：</p>
<p>object[] attrs = {new UrlAttribute("tcp://localhost:8080/ServiceMessage")};<br />object[] objs = new object[3];<br />objs[0] = "wayfarer";<br />objs[1] = "male";<br />objs[2] = 28;<br />ServerRemoteObject.ServerObject = Activator.CreateInstance(<br />typeof(ServerRemoteObject.ServerObject),objs,attrs);<br />　　可以看到，objs[]数组传递的就是构造函数的参数。</p>
<p>　　b、public static ObjectHandle CreateInstance(string assemblyName, string typeName, object[] activationAttribute);</p>
<p>　　参数说明：</p>
<p>　　assemblyName ：将在其中查找名为 typeName 的类型的程序集的名称。如果 assemblyName 为空引用（Visual Basic 中为 Nothing），则搜索正在执行的程序集。<br />　　typeName：首选类型的名称。<br />　　activationAttributes ：包含一个或多个可以参与激活的属性的数组。</p>
<p>　　参数说明一目了然。注意这个方法返回值为ObjectHandle类型，因此代码与前不同：</p>
<p>object[] attrs = {new UrlAttribute("tcp://localhost:8080/EchoMessage")}; <br />ObjectHandle handle = Activator.CreateInstance("ServerRemoteObject",<br />"ServerRemoteObject.ServerObject",attrs);<br />ServerRemoteObject.ServerObject obj = (ServerRemoteObject.ServerObject)handle.Unwrap();<br />　　这个方法实际上是调用的默认构造函数。ObjectHandle.Unwrap()方法是返回被包装的对象。</p>
<p>　　说明：要使用UrlAttribute，还需要在命名空间中添加：using System.Runtime.Remoting.Activation;</p>
<p>　　<b>五、Remoting基础的补充</b></p>
<p>　　通过上面的描述，基本上已经完成了一个最简单的Remoting程序。这是一个标准的创建Remoting程序的方法，但在实际开发过程中，我们遇到的情况也许千奇百怪，如果只掌握一种所谓的“标准”，就妄想可以“一招鲜、吃遍天”，是不可能的。</p>
<p>　　1、注册多个通道</p>
<p>　　在Remoting中，允许同时创建多个通道，即根据不同的端口创建不同的通道。但是，Remoting要求通道的名字必须不同，因为它要用来作为通道的唯一标识符。虽然IChannel有ChannelName属性，但这个属性是只读的。因此前面所述的创建通道的方法无法实现同时注册多个通道的要求。</p>
<p>　　这个时候，我们必须用到System.Collection中的IDictionary接口：</p>
<p>　　注册Tcp通道：</p>
<p>IDictionary tcpProp = new Hashtable();<br />tcpProp["name"] = "tcp9090";<br />tcpProp["port"] = 9090;<br />IChannel channel = new TcpChannel(tcpProp,<br />new BinaryClientFormatterSinkProvider(),<br />new BinaryServerFormatterSinkProvider());<br />ChannelServices.RegisterChannel(channel);<br />　　注册Http通道：</p>
<p>IDictionary httpProp = new Hashtable();<br />httpProp["name"] = "http8080";<br />httpProp["port"] = 8080;<br />IChannel channel = new HttpChannel(httpProp,<br />new SoapClientFormatterSinkProvider(),<br />new SoapServerFormatterSinkProvider());<br />ChannelServices.RegisterChannel(channel);<br />　　在name属性中，定义不同的通道名称就可以了。</p>
<p>　　2、远程对象元数据相关性</p>
<p>　　由于服务器端和客户端都要用到远程对象，通常的方式是生成两份完全相同的对象Dll，分别添加引用。不过为了代码的安全性，且降低客户端对远程对象元数据的相关性，我们有必要对这种方式进行改动。即在服务器端实现远程对象，而在客户端则删除这些实现的元数据。</p>
<p>　　由于激活模式的不同，在客户端创建对象的方法也不同，所以要分离元数据的相关性，也应分为两种情况。</p>
<p>　　(1) WellKnown激活模式：</p>
<p>　　通过接口来实现。在服务器端，提供接口和具体类的实现，而在客户端仅提供接口：</p>
<p>public interface IServerObject<br />{<br />　Person GetPersonInfo(string name,string sex,int age);<br />}</p>
<p>public class ServerObject:MarshalByRefObject,IServerObject<br />{ ......}<br />　　注意：两边生成该对象程序集的名字必须相同，严格地说，是命名空间的名字必须相同。</p>
<p>　　(2) 客户端激活模式：</p>
<p>　　如前所述，对于客户端激活模式，不管是使用静态方法，还是使用CreateInstance()方法，都必须在客户端调用构造函数实例化对象。所以，在客户端我们提供的远程对象，就不能只提供接口，而没有类的实现。实际上，要做到与远程对象元数据的分离，可以由两种方法供选择：</p>
<p>　　a、利用WellKnown激活模式模拟客户端激活模式：</p>
<p>　　方法是利用设计模式中的“抽象工厂”，下面的类图表描述了总体解决方案：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMjAwNzc3MTg1MDQ5NzM2LmdpZg==.jpg"></p>
<p>　　我们在服务器端的远程对象中加上抽象工厂的接口和实现类：</p>
<p>public interface IServerObject<br />{<br />　Person GetPersonInfo(string name,string sex,int age);<br />}</p>
<p>public interface IServerObjFactory<br />{<br />　IServerObject CreateInstance(); <br />}</p>
<p>public class ServerObject:MarshalByRefObject,IServerObject<br />{<br />　public Person GetPersonInfo(string name,string sex,int age)<br />　{<br />　　Person person = new Person();<br />　　person.Name = name;<br />　　person.Sex = sex;<br />　　person.Age = age;<br />　　return person;<br />　} <br />}</p>
<p>public class ServerObjFactory:MarshalByRefObject,IServerObjFactory<br />{<br />　public IServerObject CreateInstance()<br />　{<br />　　return new ServerObject();<br />　}<br />}<br />　　然后再客户端的远程对象中只提供工厂接口和原来的对象接口：</p>
<p>public interface IServerObject<br />{<br />　Person GetPersonInfo(string name,string sex,int age);<br />}</p>
<p>public interface IServerObjFactory<br />{<br />　IServerObject CreateInstance(); <br />}<br />　　我们用WellKnown激活模式注册远程对象，在服务器端：</p>
<p>//传递对象；<br />RemotingConfiguration.RegisterWellKnownServiceType(<br />typeof(ServerRemoteObject.ServerObjFactory),<br />"ServiceMessage",WellKnownObjectMode.SingleCall);<br />　　注意这里注册的不是ServerObject类对象，而是ServerObjFactory类对象。</p>
<p>　　客户端：</p>
<p>ServerRemoteObject.IServerObjFactory serverFactory = <br />(ServerRemoteObject.IServerObjFactory) Activator.GetObject(<br />typeof(ServerRemoteObject.IServerObjFactory),<br />"tcp://localhost:8080/ServiceMessage");</p>
<p>ServerRemoteObject.IServerObject serverObj = serverFactory.CreateInstance();<br />　　为什么说这是一种客户端激活模式的模拟呢？从激活的方法来看，我们是使用了SingleCall模式来激活对象，但此时激活的并非我们要传递的远程对象，而是工厂对象。如果客户端要创建远程对象，还应该通过工厂对象的CreateInstance()方法来获得。而这个方法正是在客户端调用的。因此它的实现方式就等同于客户端激活模式。</p>
<p>　　b、利用替代类来取代远程对象的元数据</p>
<p>　　实际上，我们可以用一个trick，来欺骗Remoting。这里所说的替代类就是这个trick了。既然是提供服务，Remoting传递的远程对象其实现的细节当然是放在服务器端。而要在客户端放对象的副本，不过是因为客户端必须调用构造函数，而采取的无奈之举。既然具体的实现是在服务器端，又为了能在客户端实例化，那么在客户端就实现这些好了。至于实现的细节，就不用管了。</p>
<p>　　如果远程对象有方法，服务器端则提供方法实现，而客户端就提供这个方法就OK了，至于里面的实现，你可以是抛出一个异常，或者return 一个null值；如果方法返回void，那么里面可以是空。关键是这个客户端类对象要有这个方法。这个方法的实现，其实和方法的声明差不多，所以我说是一个trick。方法如是，构造函数也如此。</p>
<p>　　还是用代码来说明这种“阴谋”，更直观：</p>
<p>　　服务器端：</p>
<p>public class ServerObject:MarshalByRefObject<br />{<br />public ServerObject()<br />{}</p>
<p>public Person GetPersonInfo(string name,string sex,int age)<br />{<br />　Person person = new Person();<br />　person.Name = name;<br />　person.Sex = sex;<br />　person.Age = age;<br />　return person;<br />} <br />}<br />　　客户端：</p>
<p>public class ServerObject:MarshalByRefObject<br />{<br />　public ServerObj()<br />　{<br />　　throw new System.NotImplementedException();<br />　}</p>
<p>　public Person GetPersonInfo(string name,string sex,int age)<br />　{<br />　　throw new System.NotImplementedException();<br />　} <br />}<br />　　比较客户端和服务器端，客户端的方法GetPersonInfo()，没有具体的实现细节，只是抛出了一个异常。或者直接写上语句return null，照样OK。我们称客户端的这个类为远程对象的替代类。</p>
<p>　　3、利用配置文件实现</p>
<p>　　前面所述的方法，于服务器uri、端口、以及激活模式的设置是用代码来完成的。其实我们也可以用配置文件来设置。这样做有个好处，因为这个配置文件是Xml文档。如果需要改变端口或其他，我们就不需要修改程序，并重新编译，而是只需要改变这个配置文件即可。 (1) 服务器端的配置文件：</p>
<p>＜configuration＞<br />＜system.runtime.remoting＞<br />＜application name="ServerRemoting"＞<br />＜service＞<br />＜wellknown mode="Singleton" type="ServerRemoteObject.ServerObject" objectUri="ServiceMessage"/＞<br />＜/service＞<br />＜channels＞<br />＜channel ref="tcp" port="8080"/＞<br />＜/channels＞<br />＜/application＞<br />＜/system.runtime.remoting＞<br />＜/configuration＞<br />　　如果是客户端激活模式，则把wellknown改为activated，同时删除mode属性。</p>
<p>　　把该配置文件放到服务器程序的应用程序文件夹中，命名为ServerRemoting.config。那么前面的服务器端程序直接用这条语句即可：<br />RemotingConfiguration.Configure("ServerRemoting.config");</p>
<p>　　(2) 客户端配置文件</p>
<p>　　如果是客户端激活模式，修改和上面一样。调用也是使用RemotingConfiguration.Configure()方法来调用存储在客户端的配置文件。</p>
<p>　　配置文件还可以放在machine.config中。如果客户端程序是web应用程序，则可以放在web.config中。</p>
<p>　　4、启动/关闭指定远程对象</p>
<p>　　Remoting中没有提供类似UnregisterWellKnownServiceType()的方法，也即是说，一旦通过注册了远程对象，如果没有关闭通道的话，该对象就一直存在于通道中。只要客户端激活该对象，就会创建对象实例。如果Remoting传送的只有一个远程对象，这不存在问题，关闭通道就可以了。如果传送多个远程对象呢？要关闭指定的远程对象应该怎么做？关闭之后又需要启动又该如何？</p>
<p>　　我们注意到在Remoting中提供了Marshal()和Disconnect()方法，答案就在这里。Marshal()方法是将MarshalByRefObject类对象转化为ObjRef类对象，这个对象是存储生成代理以与远程对象通讯所需的所有相关信息。这样就可以将该实例序列化以便在应用程序域之间以及通过网络进行传输，客户端就可以调用了。而Disconnect()方法则将具体的实例对象从通道中断开。</p>
<p>　　方法如下：</p>
<p>　　首先注册通道：</p>
<p>TcpChannel channel = new TcpChannel(8080);<br />ChannelServices.RegisterChannel(channel);<br />　　接着启动服务：</p>
<p>　　先在服务器端实例化远程对象。</p>
<p>ServerObject obj = new ServerObject();<br />　　然后，注册该对象。注意这里不用RemotingConfiguration.RegisterWellKnownServiceType()，而是使用RemotingServices.Marshal()：</p>
<p>ObjRef objrefWellKnown = RemotingServices.Marshal(obj, "ServiceMessage");<br />　　如果要注销对象，则：</p>
<p>RemotingServices.Disconnect(obj);<br />　　要注意，这里Disconnect的类对象必须是前面实例化的对象。正因为此，我们可以根据需要创建指定的远程对象，而关闭时，则Disconnect之前实例化的对象。</p>
<p>　　至于客户端的调用，和前面WellKnown模式的方法相同，仍然是通过Activator.GetObject()来获得。但从实现代码来看，我们会注意到一个问题，由于服务器端是显式的实例化了远程对象，因此不管客户端有多少，是否相同，它们调用的都是同一个远程对象。因此我们将这个方法称为模拟的SingleTon模式。</p>
<p>　　客户端激活模式</p>
<p>　　我们也可以通过Marshal()和Disconnect()来模拟客户端激活模式。首先我们来回顾“远程对象元数据相关性”一节，在这一节中，我说到采用设计模式的“抽象工厂”来创建对象实例，以此用SingleCall模式来模拟客户端激活模式。在仔细想想前面的模拟的SingleTon模式。是不是答案就将呼之欲出呢？</p>
<p>　　在“模拟的SingleTon”模式中，我们是将具体的远程对象实例进行Marshal，以此让客户端获得该对象的引用信息。那么我们换一种思路，当我们用抽象工厂提供接口，工厂类实现创建远程对象的方法。然后我们在服务器端创建工厂类实例。再将这个工厂类实例进行Marshal。而客户端获取对象时，不是获取具体的远程对象，而是获取具体的工厂类对象。然后再调用CreateInstance()方法来创建具体的远程对象实例。此时，对于多个客户端而言，调用的是同一个工厂类对象；然而远程对象是在各个客户端自己创建的，因此对于远程对象而言，则是由客户端激活，创建的是不同对象了。</p>
<p>　　当我们要启动/关闭指定对象时，只需要用Disconnet()方法来注销工厂类对象就可以了。</p>
<p>　　<b>六、小结</b><br />　　<br />　　Microsoft.Net Remoting真可以说是博大精深。整个Remoting的内容不是我这一篇小文所能尽述的，更不是我这个Remoting的初学者所能掌握的。王国维在《人间词话》一书中写到：古今之成大事业大学问者，必经过三种境界。“昨夜西风凋碧树，独上高楼，望尽天涯路。”此第一境界也。“衣带渐宽终不悔，为伊消得人憔悴。”此第二境界也。“众里寻他千百度，蓦然回首，那人却在灯火阑珊处。”此第三境界也。如以此来形容我对Remoting的学习，还处于“独上高楼，望尽天涯路”的时候，真可以说还未曾登堂入室。</p>
<p>　　或许需得“衣带渐宽”，学得Remoting“终不悔”，方才可以“蓦然回首”吧。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 06:49:23</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%96%b9%e6%b3%95/" title="方法">方法</a>, <a href="https://www.iamivan.net/tag/%e6%bf%80%e6%b4%bb/" title="激活">激活</a>, <a href="https://www.iamivan.net/tag/%e5%ae%a2%e6%88%b7%e7%ab%af/" title="客户端">客户端</a>, <a href="https://www.iamivan.net/tag/%e8%bf%9c%e7%a8%8b/" title="远程">远程</a>, <a href="https://www.iamivan.net/tag/%e6%a8%a1%e5%bc%8f/" title="模式">模式</a>, <a href="https://www.iamivan.net/tag/%e5%af%b9%e8%b1%a1/" title="对象">对象</a>, <a href="https://www.iamivan.net/tag/%e8%bf%9c%e7%a8%8b%e8%b0%83%e7%94%a8/" title="远程调用">远程调用</a>, <a href="https://www.iamivan.net/tag/%e8%bf%9c%e7%a8%8b%e5%88%9b%e5%bb%ba%e5%af%b9%e8%b1%a1%e7%b1%bb%e5%9e%8b/" title="&num;远程创建对象类型">&num;远程创建对象类型</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>.NET Remoting程序开发入门篇的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmBPmwz.html" rel="bookmark">微信小程序开发入门教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在这篇微信小程序开发教程中,我们将向你介绍快速试用和体验微信小程序开发工具和官方示例Demo. 本系列教程将引导你完成如下任务: 下载微信web开发者工具和小程序官方Demo. 添加小程序示例Demo到项目 体验小程序常用组件及接口   第一部分 下载开发者工具和官方Demo   微信小程序开发者工具 为了帮助开发者简单和高效地开发微信小程序,微信官方推出了全新的微信小程序开发者工具,该工具集成了开发调试.代码编辑及程序发布等功能. 下载地址为  windows 64 . windows 32 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/xp8NPBb.html" rel="bookmark">Linux 应用程序开发入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux 应用程序开发入门 Neo Chen (netkiller) &lt;openunix@163.com&gt; 版权 2011, 2012 http://netkiller.github.com 摘要 我会实现一个守护进程,从这个程序你将了解,Linux 应用程序开发基本流程 我们将实现一个远程shell的功能,可以通过tcp协议,运行远程机器上的命令或shell脚本 通过这个命令可以实现批量操作,管理上千台服务器.需要发挥你的想象力,灵活使用它. 写这个脚本,我是为了替代SSH远程操作,因为S			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/yMA8Ynb.html" rel="bookmark">C&num;&period;Net网络程序开发-Tcp篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				程序|网络 前一篇&lt;Visual C#.Net网络程序开发-Socket篇&gt;中说到:支持Http.Tcp和Udp的类组成了TCP/IP三层模型(请求响应层.应用协议层.传输层)的中间层-应用协议层,该层的类比位于最底层的Socket类提供了更高层次的抽象,它们封装 TCP 和 UDP 套接字的创建,不需要处理连接的细节,这使得我们在编写套接字级别的协议时,可以更多地尝试使用 TCPClient . UDPClient和TcpListener,而不是直接向 Socket 中写.它们之间的这种层次			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDe44rb.html" rel="bookmark">MSDN Webcast：ASP&period;NET MVC2程序开发入门到精通系列课程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				课程讲师:苏鹏 MSDN特邀讲师北京工业大学软件工程硕士,微软最有价值专家(ASP.NET MVP),微软MSDN特约讲师.曾于微软亚洲工程院MSN组工作,现任中国网通四分公司技术支持与项目部开发经理.具有多年电信系统与OA系统实施经验. 课程下载: ASP.NET MVC2程序开发入门到精通系列课程(1):MVC架构概述 ASP.NET MVC2程序开发入门到精通系列课程(2):MVC范例分享 ASP.NET MVC2程序开发入门到精通系列课程(3):MVC中的View实现技巧(上) ASP.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M08W00M.html" rel="bookmark">《微信小程序开发入门精要》&mdash;&mdash;第2章，第2&period;1节水平排列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第2章 布局微信小程序开发入门精要布局是任何支持UI的技术都会涉及到的.小程序的布局采用了和React Native相同的flex(弹性布局)方式,使用方法也类似(只是属性名不同而已).因此,如果读者已经对React Native的布局比较了解,那么将非常容易掌握小程序布局.即使对React Native的布局不了解,通过对本章的学习,也可以掌握小程序布局的核心技术. 本章要点水平排列布局水平折行排列布局垂直排列布局垂直折列排列布局水平排列对齐布局垂直排列对齐布局水平等间隔排列布局带边距的水平等			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgQo68z.html" rel="bookmark">Visual C&num;&period;Net 网络程序开发-Socket篇第1&sol;2页&lowbar;C&num;教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Visual C#.Net 网络程序开发-Socket篇   作者: 宋华  作者: www.ASPCool.com  Microsoft.Net Framework为应用程序访问Internet提供了分层的.可扩展的以及受管辖的网络服务,其名字空间System.Net和System.Net.Sockets包含丰富的类可以开发多种网络应用程序..Net类采用的分层结构允许应用程序在不同的控制级别上访问网络,开发人员可以根据需要选择针对不同的级别编制程序,这些级别几乎囊括了Internet的所有需			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBRlq9b.html" rel="bookmark">《微信小程序开发入门精要》&mdash;&mdash;第1章，第1&period;1节什么是微信小程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第1章 微信小程序入门微信小程序开发入门精要微信小程序是腾讯在2016年9月推出的一种新型的微信扩展.尽管目前还没有正式开发,但依然受到了非常多的关注.这主要是由于腾讯的影响力,以及微信在国内拥有的庞大的用户群体.在2017年1月9日,腾讯已经正式上线了小程序,这意味着任何人都可以在手机微信中使用小程序.由于目前小程序的数量还不多,所以现在进入小程序开发领域,可能会赶上小程序的第一拨红利.OK,废话少说,从本章开始,让我们深入了解微信小程序的原理以及详细的开发过程. 本章要点什么是微信小程序注册			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pP2YXmb.html" rel="bookmark">Visual C&num;&period;Net网络程序开发-Tcp篇（2） 祥细内容：</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前面我们说,TcpClient类创建在Socket之上,在Tcp服务方面提供了更高层次的抽象,体现在网络数据的发送和接受方面,是TcpClient使用标准的Stream流处理技术,使得它读写数据更加方便直观,同时,.Net框架负责提供更丰富的结构来处理流,贯穿于整个.Net框架中的流具有更广泛的兼容性,构建在更一般化的流操作上的通用方法使我们不再需要困惑于文件的实际内容(HTML.XML 或其他任何内容),应用程序都将使用一致的方法(Stream.Write.Stream.Read) 发送和接收			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9J1KKp.html" rel="bookmark">一起谈&period;NET技术，MSDN Webcast：ASP&period;NET MVC2程序开发入门到精通系列课程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				课程讲师:苏鹏 MSDN特邀讲师北京工业大学软件工程硕士,微软最有价值专家(ASP.NET MVP),微软MSDN特约讲师.曾于微软亚洲工程院MSN组工作,现任中国网通四分公司技术支持与项目部开发经理.具有多年电信系统与OA系统实施经验. 课程下载: ASP.NET MVC2程序开发入门到精通系列课程(1):MVC架构概述 ASP.NET MVC2程序开发入门到精通系列课程(2):MVC范例分享 ASP.NET MVC2程序开发入门到精通系列课程(3):MVC中的View实现技巧(上) ASP.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6ZEgM.html" rel="bookmark" class="title">PS鼠绘阿凡达电影插画</a>
					<div>
						教程介绍难度较大的3D场景的鼠绘.可能需要一定的美术基础.因为3D画看上去比较真实,需要了解立体人物的建模及绘画技巧.制作的时候可以选择一些数位板来画. 最终效果 1.首先,我们定出基本的颜色和色调, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkVmjM.html" rel="bookmark" class="title">连接ACCESS数据库时发生错误提示&colon;找不到可安装的 ISAM</a>
					<div>
						连接ACCESS数据库时发生错误提示:找不到可安装的 ISAM 检查后发现原来是把Data Source写成 DataSource了 错误:&lt;add key=&quot;OleConnectio ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQv7OM.html" rel="bookmark" class="title">添加到收藏夹的Javascript脚本 for ie&comma;firefox</a>
					<div>
						javascript|脚本 代码: &lt;script type=&quot;text/javascript&quot;&gt;function addBookmark(title,url) {if ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMy164M.html" rel="bookmark" class="title">网页结构中id与class的使用原则与技巧</a>
					<div>
						技巧|网页 在前几日的文章中我提到过XHTML的重要性,在那篇文章中我讲了为什么说XHTML结构重要,重视XHTML结构的好处.但是那篇文章从开发的效率入手,并没有深入细节,而今天的这篇文章是讲XHT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYmlQM.html" rel="bookmark" class="title">有效发挥数据库的最大效率</a>
					<div>
						数据|数据库 有效发挥数据库的最大效率 snapbug Dec 2003  1.     前言 数据库应用,在许多软件系统中经常用到,是开发中大型系统不可缺少的辅助.但如果对数据库资源没有很好地管理( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyljGb.html" rel="bookmark" class="title">关闭win7系统&OpenCurlyDoubleQuote;window安全网络身份验证&rdquo;窗口教程</a>
					<div>
						  关闭win7系统&quot;window安全网络身份验证&quot;窗口教程 1.遇到的提示如下; 2.在桌面右下角点击网络连接图标选择打开网络和共享中心; 3.选择更改适配器设置; 4.右击本地 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPdd8z.html" rel="bookmark" class="title">WindowsXP的系统恢复全攻略</a>
					<div>
						  1.什么是系统恢复?     利用Windows XP的系统恢复功能,用户(系统管理员和所有者)在遇到问题时可将机器还原到以前的状态.系统恢复功能自动监控系统文件的更改和某些应用程序文件的更改,记 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOen0M.html" rel="bookmark" class="title">谈用PPT完成板书效果</a>
					<div>
						在Flash中通过很多的图层.帧和语句在课件的表格中实现了板书的效果(即填写一格内容时其他格的内容不会消失).这对于不熟悉Flash软件的教师来说有些困难.其实这种效果用PowerPoint就可以轻松 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq820Kb.html" rel="bookmark" class="title">IE浏览器修复怎么修教程</a>
					<div>
						  虽然现在很多人使用其他浏览器,但IE浏览器在访问网银的时候还是很多人使用相对安全,但IE并不稳定,如果受到恶意软件的破坏,浏览器便会不正常,要么不显示视频不显示图片,要么无法打开网页,出现这种情况 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24yD3p.html" rel="bookmark" class="title">Photoshop调出后期人像照片复古炫美色调</a>
					<div>
						只要有明媚生活的希翼,终究绽放绚丽的色彩,可以是自己想要明媚的样子.温暖身边的人,也温暖自己.这次后期教程除了皮肤再造调色外,还有复古的&quot;炫光色&quot;处理,希望对之前对此色调感兴趣的会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3o53M.html" rel="bookmark" class="title">360安全卫士怎么查看被拒绝安装的软件名单&quest;</a>
					<div>
						  当我们想安装某些软件的时候,会发现一直安装不了,导致这个的原因是你要安装的软件,可能被360安全卫士拒绝了,那么该怎么查看360安全卫士被拒接安装的软件名单呢?下面就教大家一个方法. 方法步骤 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQND3wM.html" rel="bookmark" class="title">如何清理win7系统C盘的技巧</a>
					<div>
						  1.删除一些功能带来的应用程序缓存:进入c盘,将c:windowsprefetch 文件夹中的文件全部删除即可; 2.清理IE浏览器产生的临时文件:依次进入&quot;开始菜单-控制面板-Inte ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEW223p.html" rel="bookmark" class="title">删除恶意代码让win xp系统免受侵扰</a>
					<div>
						  WindowsXP删除恶意代码的方法: 1.解开被禁用的注册表 执行软盘中的&quot;unlockreg.reg&quot;文件,此文件是用记事本建立一个以REG为后缀名的文件,文件名可自定义, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0QVV7p.html" rel="bookmark" class="title">&lbrack;翻译&rsqb;Axure-Dynamic Panel&lpar;Basic&rpar;-原型设计工具Axure学习-第2&period;1节</a>
					<div>
						Hide and show with Dynamic Panel(Basic) Dynamic Panel允许你隐藏,显示,交换和移动wireframe的内容.本章节讲述dynamic panels的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxeLdb.html" rel="bookmark" class="title">java操作excel，用jxl将多个excel文件合并成一个多sheet的excel文件，颜色会出错</a>
					<div>
						问题描述 java操作excel,用jxl将多个excel文件合并成一个多sheet的excel文件,颜色会出错 程序代码如下: public class Main { public static v ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2Yjeb.html" rel="bookmark" class="title">计算机组成原理-指令系统和控制器的设计</a>
					<div>
						问题描述 指令系统和控制器的设计 我们期末项目,要做一款电子产品,我们小组选择的是电子药盒(功能是定时提醒,文字信息显示,录音功能),需要设计指令系统和设计一款控制器,请问谁有这方面的资料,帮帮我吧, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmJXmM.html" rel="bookmark" class="title">怎样从安全证书中提取用户的公钥？</a>
					<div>
						问题描述 如题 解决方案 解决方案二:该回复于2007-12-04 11:18:56被版主删除解决方案三:ToexportthepublickeycertificatefromtheMycertifi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Rnyrb.html" rel="bookmark" class="title">云计算数据中心里的&OpenCurlyDoubleQuote;哲学&rdquo;与绿色</a>
					<div>
						中国IDC圈7月17日报道:使用云计算就是把信息处理任务交付给数据中心去处理.下一代数据中心大多采用虚拟化技术,把一台物理硬件服务器分割成多台逻辑虚拟机,可同时执行多个信息处理任务,使昂贵稀缺的计算资 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJA6E6p.html" rel="bookmark" class="title">要慎重对待广告任务网</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 很多网赚博客,网赚网站的站长,很热 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4ey8Nb.html" rel="bookmark" class="title">WP开发者曝光称微软一开始内部测试WP8&period;1</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;   当桌面用户的目光都集中在本月即将推出的Windows  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4emQ9b.html" rel="bookmark" class="title">哪位朋友用过azure， 能说一下你的使用体会么？</a>
					<div>
						问题描述 哪位朋友用过azure, 能说一下你的使用体会么? 哪位朋友用过azure, 能说一下你的使用体会么?求大神指教!! 解决方案 windows azure 试用感受 http://blog. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeAXZM.html" rel="bookmark" class="title">MATLAB的小波变换实现ofdm</a>
					<div>
						问题描述 MATLAB的小波变换实现ofdm 实现电力线通信,是基于小波变换的ofdm的通信系统,主要是关于小波变换的那一部分 解决方案 http://www.docin.com/p-66441549 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQANBp.html" rel="bookmark" class="title">《Linux高性能服务器编程》&mdash;&mdash;3&period;5　复位报文段</a>
					<div>
						3.5 复位报文段 在某些特殊条件下,TCP连接的一端会向另一端发送携带RST标志的报文段,即复位报文段,以通知对方关闭连接或重新建立连接.本节讨论产生复位报文段的3种情况. 3.5.1 访问不存在的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnR1aWp.html" rel="bookmark" class="title">海豚浏览器公测版本发布 跑分之争继续上演</a>
					<div>
						近日,据相关消息报道,百纳信息发布海豚浏览器公测版本. 跑分之争继续上演 百纳信息在发给媒体的新闻稿中表示,此次发布的公测版本,主推自主研发的450内核,全面支持HTML5标准.而在Android4. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jJn4p.html" rel="bookmark" class="title">Python对象的深拷贝和浅拷贝详解&lowbar;python</a>
					<div>
						本文内容是在&lt;Python核心编程2&gt;上看到的,感觉很有用便写出来,给大家参考参考! 浅拷贝 首先我们使用两种方式来拷贝对象,一种是切片,另外一种是工厂方法.然后使用id函数来看看它们的标 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgE7WZz.html" rel="bookmark" class="title">《JavaScript机器人编程指南》&mdash;&mdash;1&period;3　Johnny-Five和NodeBot的革新</a>
					<div>
						1.3 Johnny-Five和NodeBot的革新 Johnny-Five是一个开源的Node.JS机器人技术库.它由Rick Waldron创建并且有由贡献者和支持者组成的活跃社区.在基于Node ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlEYAp.html" rel="bookmark" class="title">课后作业求助&comma;如何访问iframe页面的值&quest;</a>
					<div>
						问题描述 主宿页面如何访问iframe页面的值?cpmanager.aspx:&lt;asp:ButtonID=&quot;Button1&quot;runat=&quot;server&quot;O ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK05o5M.html" rel="bookmark" class="title">Ubuntu系统下最基本的网络设置</a>
					<div>
						http://www.aliyun.com/zixun/aggregation/13835.html&quot;&gt;Ubuntu系统下的网络设置,包括多种:设置双网卡.单网卡绑定多IP等,这里面我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNm0Ydb.html" rel="bookmark" class="title">打开摄像头-opencv 1&period;0无法打开联想的摄像头，求解决方案</a>
					<div>
						问题描述 opencv 1.0无法打开联想的摄像头,求解决方案 enter code here #include &quot;highgui.h&quot; #include &quot;cv.h&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPWvYAM.html" rel="bookmark" class="title">腾讯宣布QQ旋风云播放因业务升级调整暂停服务</a>
					<div>
						域名城(domain.cn)11月11日消息,腾讯近日宣布,http://www.aliyun.com/zixun/aggregation/8422.html&quot;&gt;QQ旋风云播放功能已于 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.045 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
